Skip excessive blank lines before commit body
[git/dscho.git] / t / test-lib.sh
blobbf108d4226fabf847f42420547471dfb3cef8a8e
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset AUTHOR_DATE
15 unset AUTHOR_EMAIL
16 unset AUTHOR_NAME
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20 unset GIT_AUTHOR_DATE
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_DIFF_OPTS
27 unset GIT_DIR
28 unset GIT_EXTERNAL_DIFF
29 unset GIT_INDEX_FILE
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
33 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
35 export EDITOR VISUAL
37 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
38 1|2|true)
39 echo "* warning: Some tests will not work if GIT_TRACE" \
40 "is set as to trace on STDERR ! *"
41 echo "* warning: Please set GIT_TRACE to something" \
42 "other than 1, 2 or true ! *"
44 esac
46 # Each test should start with something like this, after copyright notices:
48 # test_description='Description of this test...
49 # This test checks if command xyzzy does the right thing...
50 # '
51 # . ./test-lib.sh
53 error () {
54 echo "* error: $*"
55 trap - exit
56 exit 1
59 say () {
60 echo "* $*"
63 test "${test_description}" != "" ||
64 error "Test script did not set test_description."
66 while test "$#" -ne 0
68 case "$1" in
69 -d|--d|--de|--deb|--debu|--debug)
70 debug=t; shift ;;
71 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
72 immediate=t; shift ;;
73 -h|--h|--he|--hel|--help)
74 echo "$test_description"
75 exit 0 ;;
76 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
77 verbose=t; shift ;;
78 --no-python)
79 # noop now...
80 shift ;;
82 break ;;
83 esac
84 done
86 exec 5>&1
87 if test "$verbose" = "t"
88 then
89 exec 4>&2 3>&1
90 else
91 exec 4>/dev/null 3>/dev/null
94 test_failure=0
95 test_count=0
97 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
99 test_tick () {
100 if test -z "${test_tick+set}"
101 then
102 test_tick=432630000
103 else
104 test_tick=$(($test_tick + 60))
106 GIT_COMMITTER_DATE=$test_tick
107 GIT_AUTHOR_DATE=$test_tick
108 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
111 # You are not expected to call test_ok_ and test_failure_ directly, use
112 # the text_expect_* functions instead.
114 test_ok_ () {
115 test_count=$(expr "$test_count" + 1)
116 say " ok $test_count: $@"
119 test_failure_ () {
120 test_count=$(expr "$test_count" + 1)
121 test_failure=$(expr "$test_failure" + 1);
122 say "FAIL $test_count: $1"
123 shift
124 echo "$@" | sed -e 's/^/ /'
125 test "$immediate" = "" || { trap - exit; exit 1; }
129 test_debug () {
130 test "$debug" = "" || eval "$1"
133 test_run_ () {
134 eval >&3 2>&4 "$1"
135 eval_ret="$?"
136 return 0
139 test_skip () {
140 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
141 this_test="$this_test.$(expr "$test_count" + 1)"
142 to_skip=
143 for skp in $GIT_SKIP_TESTS
145 case "$this_test" in
146 $skp)
147 to_skip=t
148 esac
149 done
150 case "$to_skip" in
152 say >&3 "skipping test: $@"
153 test_count=$(expr "$test_count" + 1)
154 say "skip $test_count: $1"
155 : true
158 false
160 esac
163 test_expect_failure () {
164 test "$#" = 2 ||
165 error "bug in the test script: not 2 parameters to test-expect-failure"
166 if ! test_skip "$@"
167 then
168 say >&3 "expecting failure: $2"
169 test_run_ "$2"
170 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
171 then
172 test_ok_ "$1"
173 else
174 test_failure_ "$@"
177 echo >&3 ""
180 test_expect_success () {
181 test "$#" = 2 ||
182 error "bug in the test script: not 2 parameters to test-expect-success"
183 if ! test_skip "$@"
184 then
185 say >&3 "expecting success: $2"
186 test_run_ "$2"
187 if [ "$?" = 0 -a "$eval_ret" = 0 ]
188 then
189 test_ok_ "$1"
190 else
191 test_failure_ "$@"
194 echo >&3 ""
197 test_expect_code () {
198 test "$#" = 3 ||
199 error "bug in the test script: not 3 parameters to test-expect-code"
200 if ! test_skip "$@"
201 then
202 say >&3 "expecting exit code $1: $3"
203 test_run_ "$3"
204 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
205 then
206 test_ok_ "$2"
207 else
208 test_failure_ "$@"
211 echo >&3 ""
214 # Most tests can use the created repository, but some amy need to create more.
215 # Usage: test_create_repo <directory>
216 test_create_repo () {
217 test "$#" = 1 ||
218 error "bug in the test script: not 1 parameter to test-create-repo"
219 owd=`pwd`
220 repo="$1"
221 mkdir "$repo"
222 cd "$repo" || error "Cannot setup test environment"
223 "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
224 error "cannot run git init-db -- have you built things yet?"
225 mv .git/hooks .git/hooks-disabled
226 cd "$owd"
229 test_done () {
230 trap - exit
231 case "$test_failure" in
233 # We could:
234 # cd .. && rm -fr trash
235 # but that means we forbid any tests that use their own
236 # subdirectory from calling test_done without coming back
237 # to where they started from.
238 # The Makefile provided will clean this test area so
239 # we will leave things as they are.
241 say "passed all $test_count test(s)"
242 exit 0 ;;
245 say "failed $test_failure among $test_count test(s)"
246 exit 1 ;;
248 esac
251 # Test the binaries we have just built. The tests are kept in
252 # t/ subdirectory and are run in trash subdirectory.
253 PATH=$(pwd)/..:$PATH
254 GIT_EXEC_PATH=$(pwd)/..
255 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
256 HOME=$(pwd)/trash
257 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR HOME
259 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
260 export GITPERLLIB
261 test -d ../templates/blt || {
262 error "You haven't built things yet, have you?"
265 # Test repository
266 test=trash
267 rm -fr "$test"
268 test_create_repo $test
269 cd "$test"
271 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
272 for skp in $GIT_SKIP_TESTS
274 to_skip=
275 for skp in $GIT_SKIP_TESTS
277 case "$this_test" in
278 $skp)
279 to_skip=t
280 esac
281 done
282 case "$to_skip" in
284 say >&3 "skipping test $this_test altogether"
285 say "skip all tests in $this_test"
286 test_done
287 esac
288 done